/*
     srgp_mem.c
     Provides global dynamic memory allocation using Windows Local dynamic
     allocation functions.
*/

#include "srgplocal.h"

#define MAX_GLOBAL_BLOCKS 32

static WORD globalBlocks[MAX_GLOBAL_BLOCKS];
static WORD currentBlock;
static int numBlocks = 0;
           
           
           
           
boolean
SRGP__memInit()
{
   return TRUE;
}

void FAR *
SRGP_malloc (unsigned long size)
{                
   HGLOBAL   handle;
   char FAR *addr;
 
   handle = GlobalAlloc (GPTR, size + sizeof(handle));
   if (!handle)
      return NULL;
      
   addr = GlobalLock  (handle);
   *(HGLOBAL FAR *)addr = handle;
   addr += sizeof (handle);
   
   return addr;
}


void FAR *
SRGP_realloc (void far *ptr, unsigned long size)
{ 
   HGLOBAL   handle;
   char FAR *addr;
     
   if (!ptr)
      return SRGP_malloc (size);         
   else if (!size)
   {
      SRGP_free (ptr);
      return NULL;
   }
   
   handle = *(HGLOBAL FAR *)((char FAR *)ptr - sizeof(handle));  
   GlobalUnlock (handle);
   handle = GlobalReAlloc (handle, size, GMEM_ZEROINIT);
   if (!handle)
      return NULL;
   
   addr = GlobalLock  (handle);
   *(HGLOBAL FAR *)addr = handle;
   addr += sizeof (handle);
       
   return addr; 
}

void 
SRGP_free (void far *ptr)               
{          
   HGLOBAL handle;
         
   if (!ptr)
      return;
   
   handle = *(HGLOBAL FAR *)((char FAR *)ptr - sizeof(handle));
   GlobalUnlock (handle);
   GlobalFree (handle);
}

void SRGP__memFree()
{
}